%% Example 3 - Linear Regression
clc;
clear all;
close all;

x=[5 4.3 2 3.3 8 1.5 3.4 7.2 4.3 6.7 9.8 1.2]'; % input
t=[-0.30 -0.19 -0.11 -0.18 -0.20 0.03 0.15 0.31 -0.21 0.23 0.26 0.12]'; % target output
f=(1./x); %Basis Function f(x)=1/x

%plot(f,t, 'ro')
%% Part A
fprintf('\nPart A:\n')
Fi=[ones(12,1) f];
%Regularization coefficient l=0.4
Wml=inv(0.5*eye(2)+Fi'*Fi)*(Fi'*t);
h=Wml(1)+(Wml(2)*f);
% plot(f,h,'b*')
error=sum((h-t).^2)
%% Part B
fprintf('\nPart B:\n')
 x=[5 4.3 2 3.3 8 1.5]';
 t=[-0.30 -0.19 -0.11 -0.18 -0.20 0.03]'; % target output
% % input
 f=(1./x);
 Fi=[ones(6,1) f];
% 
% Regularization coefficient l
l=[0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1];
for i=1:length(l)
    W(i,:)=inv(l(i)*eye(2)+Fi'*Fi)*(Fi'*t);
    %disp(W(i,:));
    %fprintf('\n');
end

clear i error; 
for i=1:length(l)
    error(i)=0;
    for k=1:length(x)
        h(i,k)=W(i,1)+(W(i,2)*f(k));
        error(i)=error(i)+((h(i,k)-t(k)).^2);
    end
end

%disp(h)
disp(error)